diff --git a/src/dynamic-plugins/sf_engine/sf_snort_packet.h b/src/dynamic-plugins/sf_engine/sf_snort_packet.h
index ba6da44..b229cd3 100644
--- a/src/dynamic-plugins/sf_engine/sf_snort_packet.h
+++ b/src/dynamic-plugins/sf_engine/sf_snort_packet.h
@@ -382,6 +382,148 @@ typedef struct _ICMP6
 struct _SFSnortPacket;
 
 
+/* Snort redefines much of decoder.h here for unknown reasons. */
+typedef struct _SCTPIpParam2
+{
+    u_int16_t ptype;
+	u_int16_t plen;
+	union
+	{
+		struct _ipv4
+		{
+			u_int32_t address;
+			u_int32_t padding1;
+			u_int32_t padding2;
+			u_int32_t padding3;
+		} ipv4;
+		struct in6_addr ipv6;
+	} address;
+} SCTPIpParam2;
+
+typedef struct _SCTPHeader
+{
+    u_int16_t source_port;          /* source port */
+    u_int16_t destination_port;     /* destination port */
+    u_int32_t verification_tag;     /* verification tag */
+    u_int32_t checksum;             /* checksum */
+	u_int8_t chunk_type;            /* chunk type */
+	u_int8_t chunk_flags;           /* chunk flags */
+	u_int16_t chunk_length;         /* chunk length */
+    void *chunks;                   /* chunk(s) data pointer */
+} SCTPHeader;
+
+typedef union _SCTPChunkData
+{
+    struct data_chunk
+    {
+        u_int32_t tsn;
+        u_int16_t stream_id;
+        u_int16_t stream_seq;
+        u_int32_t pp_id;
+        void *data;
+    } data;
+
+    struct init_chunk
+    {
+        u_int32_t init_tag;
+        u_int32_t a_rwnd;
+        u_int16_t num_out_streams;
+        u_int16_t num_in_streams;
+        u_int32_t tsn;
+        void *parameters;
+    } init;
+
+    struct init_ack_chunk
+    {
+        u_int32_t init_tag;
+        u_int32_t a_rwnd;
+        u_int16_t num_out_streams;
+        u_int16_t num_in_streams;
+        u_int32_t tsn;
+        void *parameters;
+    } init_ack;
+
+    struct sack_chunk
+    {
+        u_int32_t tsn_ack;
+        u_int32_t a_rwnd;
+        u_int16_t n_gap_acks;
+        u_int16_t n_dupe_tsns;
+        void *data;
+    } sack;
+
+    struct heartbeat_chunk
+    {
+        void *parameters;
+    } heartbeat;
+
+    struct heartbeat_ack_chunk
+    {
+        void *parameters;
+    } heartbeat_ack;
+
+    struct abort_chunk
+    {
+        void *causes;
+    } abort;
+
+    struct shutdown_chunk
+    {
+        u_int32_t tsn_ack;
+    } shutdown;
+
+    /* No struct for shutdown_ack. */
+
+    struct error_chunk
+    {
+        void *errors;
+    } error;
+
+    struct cookie_echo_chunk
+    {
+        char *cookie;
+    } cookie_echo;
+
+    /* No struct for cookie_ack. */
+
+    /* No struct for ecne (reserved). */
+
+    /* No struct for cwr (reserved). */
+
+    /* No struct for shutdown_complete. */
+
+    struct auth_chunk
+    {
+        u_int16_t skey_id;
+        u_int16_t hmac_id;
+        void *hmac;
+    } auth;
+
+    struct asconf_ack_chunk
+    {
+        u_int32_t seq;
+        void *parameters;
+    } asconf_ack;
+
+    struct pad_chunk
+    {
+        void *data;
+    } pad;
+
+    struct forward_tsn_chunk
+    {
+        u_int32_t new_tsn;
+        void *streams;
+    } forward_tsn;
+
+    struct asconf_chunk
+    {
+        u_int32_t seq;
+        SCTPIpParam2 *addr;
+        void *parameters;
+    } asconf;
+} SCTPChunkData;
+
 /* IPHeader access calls */
 sfip_t *    ip4_ret_src(const struct _SFSnortPacket *);
 sfip_t *    ip4_ret_dst(const struct _SFSnortPacket *);
@@ -521,6 +663,7 @@ typedef struct _SFSnortPacket
     const UDPHeader *inner_udph;   /* if Teredo + UDP, this will be the inner UDP header */
     const UDPHeader *outer_udph;   /* if Teredo + UDP, this will be the outer UDP header */
     const ICMPHeader *icmp_header, *orig_icmp_header;
+    const SCTPHeader *sctp_header, *orig_sctp_header;
 
     const uint8_t *payload;
     const uint8_t *ip_payload;
@@ -665,14 +808,16 @@ typedef struct _SFSnortPacket
 #define PROTO_BIT__ARP      0x0002
 #define PROTO_BIT__TCP      0x0004
 #define PROTO_BIT__UDP      0x0008
-#define PROTO_BIT__ICMP     0x0010
-#define PROTO_BIT__TEREDO   0x0020
+#define PROTO_BIT__SCTP     0x0010
+#define PROTO_BIT__ICMP     0x0020
+#define PROTO_BIT__TEREDO   0x0040
 #define PROTO_BIT__ALL      0xffff
 
 #define IsIP(p) (IPH_IS_VALID(p))
 #define IsTCP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_TCP))
 #define IsUDP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_UDP))
 #define IsICMP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_ICMP))
+#define IsSCTP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_SCTP))
 
 #define SET_IP4_VER(ip_header, value) \
     ((ip_header)->version_headerlength = \
diff --git a/src/fpcreate.c b/src/fpcreate.c
index 39b550c..6f48dc1 100644
--- a/src/fpcreate.c
+++ b/src/fpcreate.c
@@ -237,6 +237,9 @@ static srmm_table_t * ServiceMapNew(void)
     table->udp_to_srv = alloc_srvmap();
     table->udp_to_cli = alloc_srvmap();
 
+    table->sctp_to_srv = alloc_srvmap();
+    table->sctp_to_cli = alloc_srvmap();
+
     table->icmp_to_srv = alloc_srvmap();
     table->icmp_to_cli = alloc_srvmap();
 
@@ -261,6 +264,8 @@ static void ServiceMapFree(srmm_table_t *srvc_map)
     ServiceTableFree(srvc_map->tcp_to_cli);
     ServiceTableFree(srvc_map->udp_to_srv);
     ServiceTableFree(srvc_map->udp_to_cli);
+    ServiceTableFree(srvc_map->sctp_to_srv);
+    ServiceTableFree(srvc_map->sctp_to_cli);
     ServiceTableFree(srvc_map->icmp_to_srv);
     ServiceTableFree(srvc_map->icmp_to_cli);
     ServiceTableFree(srvc_map->ip_to_srv);
@@ -297,6 +302,9 @@ static srmm_table_t * ServicePortGroupMapNew(void)
     table->udp_to_srv = alloc_spgmm();
     table->udp_to_cli = alloc_spgmm();
 
+    table->sctp_to_srv = alloc_spgmm();
+    table->sctp_to_cli = alloc_spgmm();
+
     table->icmp_to_srv = alloc_spgmm();
     table->icmp_to_cli = alloc_spgmm();
 
@@ -341,6 +349,8 @@ static void ServicePortGroupMapFree(srmm_table_t *srvc_pg_map)
     ServicePortGroupTableFree(srvc_pg_map->tcp_to_cli);
     ServicePortGroupTableFree(srvc_pg_map->udp_to_srv);
     ServicePortGroupTableFree(srvc_pg_map->udp_to_cli);
+    ServicePortGroupTableFree(srvc_pg_map->sctp_to_srv);
+    ServicePortGroupTableFree(srvc_pg_map->sctp_to_cli);
     ServicePortGroupTableFree(srvc_pg_map->icmp_to_srv);
     ServicePortGroupTableFree(srvc_pg_map->icmp_to_cli);
     ServicePortGroupTableFree(srvc_pg_map->ip_to_srv);
@@ -408,6 +418,11 @@ static int ServiceMapAddOtn(srmm_table_t *srmm, int proto, char *servicename, Op
         to_srv = srmm->udp_to_srv;
         to_cli = srmm->udp_to_cli;
     }
+    else if( proto == IPPROTO_SCTP)
+    {
+        to_srv = srmm->sctp_to_srv;
+        to_cli = srmm->sctp_to_cli;
+    }
     else if( proto == IPPROTO_ICMP )
     {
         to_srv = srmm->icmp_to_srv;
@@ -473,6 +488,12 @@ int prmFindRuleGroupUdp(PORT_RULE_MAP *prm, int dport, int sport, PORT_GROUP **
     return prmFindRuleGroup( prm, dport, sport, src, dst , gen);
 }
 
+int prmFindRuleGroupSctp(PORT_RULE_MAP *prm, int dport, int sport, PORT_GROUP ** src,
+                        PORT_GROUP **dst , PORT_GROUP ** gen)
+{
+    return prmFindRuleGroup( prm, dport, sport, src, dst , gen);
+}
+
 void free_detection_option_root(void **existing_tree)
 {
     detection_option_tree_root_t *root;
@@ -1858,7 +1879,7 @@ static int fpAddPortGroupRule(PORT_GROUP *pg, OptTreeNode *otn, FastPatternConfi
  *
  *  Generation of PortRuleMaps and data is done differently.
  *
- *    1) Build tcp/udp/icmp/ip src and dst PORT_GROUP objects based on the PortList Objects rules.
+ *    1) Build tcp/udp/sctp/icmp/ip src and dst PORT_GROUP objects based on the PortList Objects rules.
  *
  *    2) For each protocols PortList objects walk it's ports and assign the PORT_RULE_MAP src and dst
  *         PORT_GROUP[port] array pointers to that PortList objects PORT_GROUP.
@@ -1868,7 +1889,7 @@ static int fpAddPortGroupRule(PORT_GROUP *pg, OptTreeNode *otn, FastPatternConfi
  *    Each PortList Object will be translated into a PORT_GROUP, than pointed to by the
  *    PORT_GROUP array in the PORT_RULE_MAP for the procotocol
  *
- *    protocol = tcp, udp, ip, icmp - one port_rule_map for each of these protocols
+ *    protocol = tcp, udp, sctp, ip, icmp - one port_rule_map for each of these protocols
  *    { create a port_rule_map
  *      dst port processing
  *          for each port-list object create a port_group object
@@ -2037,6 +2058,13 @@ static int fpCreateRuleMaps(SnortConfig *sc, rule_port_tables_t *p)
     if (fpCreateInitRuleMap(sc->prmUdpRTNX, p->udp_src, p->udp_dst, p->udp_anyany,p->udp_nocontent))
         return -1;
 
+    sc->prmSctpRTNX = prmNewMap();
+    if (sc->prmSctpRTNX == NULL)
+        return -1;
+
+    if (fpCreateInitRuleMap(sc->prmSctpRTNX, p->sctp_src, p->sctp_dst, p->sctp_anyany,p->sctp_nocontent))
+        return -1;
+
     sc->prmIpRTNX = prmNewMap();
     if (sc->prmIpRTNX == NULL)
         return 1;
@@ -2071,6 +2099,12 @@ static void fpFreeRuleMaps(SnortConfig *sc)
         sc->prmUdpRTNX = NULL;
     }
 
+    if (sc->prmSctpRTNX != NULL)
+    {
+        free(sc->prmSctpRTNX);
+        sc->prmSctpRTNX = NULL;
+    }
+
     if (sc->prmIpRTNX != NULL)
     {
         free(sc->prmIpRTNX);
@@ -2554,7 +2588,7 @@ static int fpCreatePortGroups(SnortConfig *sc, rule_port_tables_t *p)
 
     if (fpCreatePortTablePortGroups(sc, p->udp_dst, add_any_any))
     {
-        LogMessage("fpCreatePorTablePortGroups failed-udp_src\n");
+        LogMessage("fpCreatePorTablePortGroups failed-udp_dst\n");
         return -1;
     }
 
@@ -2563,7 +2597,7 @@ static int fpCreatePortGroups(SnortConfig *sc, rule_port_tables_t *p)
 
     if (fpCreatePortObject2PortGroup(sc, po2, 0))
     {
-        LogMessage("fpCreatePorTablePortGroups failed-udp_src\n");
+        LogMessage("fpCreatePorTablePortGroups failed-udp_any-any\n");
         return -1;
     }
 
@@ -2573,6 +2607,47 @@ static int fpCreatePortGroups(SnortConfig *sc, rule_port_tables_t *p)
     //LogMessage("fpcreate: calling PortObjectFree2(po2), line = %d\n",__LINE__ );
     PortObject2Free(po2);
 
+    /* SCTP */
+    po2 = PortObject2Dup(p->sctp_anyany);
+    if (po2 == NULL )
+        FatalError("Could not create a PortObject version 2 for sctp-any-any rules\n!");
+
+    if (!fpDetectSplitAnyAny(fp))
+        add_any_any = po2;
+
+    if (fpDetectGetDebugPrintRuleGroupBuildDetails(fp))
+        LogMessage("\nSCTP-SRC ");
+
+    if (fpCreatePortTablePortGroups(sc, p->sctp_src, add_any_any))
+    {
+        LogMessage("fpCreatePorTablePortGroups failed-sctp_src\n");
+        return -1;
+    }
+
+    if (fpDetectGetDebugPrintRuleGroupBuildDetails(fp))
+        LogMessage("\nSCTP-DST ");
+
+    if (fpCreatePortTablePortGroups(sc, p->sctp_dst, add_any_any))
+    {
+        LogMessage("fpCreatePorTablePortGroups failed-sctp_dst\n");
+        return -1;
+    }
+
+    if (fpDetectGetDebugPrintRuleGroupBuildDetails(fp))
+        LogMessage("\nSCTP-ANYANY ");
+
+    if (fpCreatePortObject2PortGroup(sc, po2, 0))
+    {
+        LogMessage("fpCreatePorTablePortGroups failed-sctp_any-any\n");
+        return -1;
+    }
+
+    p->sctp_anyany->data = po2->data;
+    p->sctp_anyany->data_free = fpDeletePortGroup;
+    po2->data = 0;
+    //LogMessage("fpcreate: calling PortObjectFree2(po2), line = %d\n",__LINE__ );
+    PortObject2Free(po2);
+
     /* ICMP */
     po2 = PortObject2Dup(p->icmp_anyany);
     if (po2 == NULL)
@@ -2595,7 +2670,7 @@ static int fpCreatePortGroups(SnortConfig *sc, rule_port_tables_t *p)
 
     if (fpCreatePortTablePortGroups(sc, p->icmp_dst, add_any_any))
     {
-        LogMessage("fpCreatePorTablePortGroups failed-icmp_src\n");
+        LogMessage("fpCreatePorTablePortGroups failed-icmp_dst\n");
         return -1;
     }
 
@@ -2695,7 +2770,8 @@ void fpWalkOtns(int enabled, OtnWalkFcn fcn)
                 continue;
 
             if ((rtn->proto == IPPROTO_TCP) || (rtn->proto == IPPROTO_UDP)
-                || (rtn->proto == IPPROTO_ICMP) || (rtn->proto == ETHERNET_TYPE_IP))
+                || (rtn->proto == IPPROTO_SCTP) || (rtn->proto == IPPROTO_ICMP)
+                || (rtn->proto == ETHERNET_TYPE_IP))
             {
                 //do operation
                 if ( enabled && (otn->rule_state != RULE_STATE_ENABLED) )
@@ -2732,7 +2808,8 @@ static int fpCreateServiceMaps(SnortConfig *sc)
             rtn = getRtnFromOtn(otn, policyId);
 
             if (rtn && ((rtn->proto == IPPROTO_TCP) || (rtn->proto == IPPROTO_UDP)
-                    || (rtn->proto == IPPROTO_ICMP) || (rtn->proto == ETHERNET_TYPE_IP)))
+                    || (rtn->proto == IPPROTO_SCTP) || (rtn->proto == IPPROTO_ICMP)
+                    || (rtn->proto == ETHERNET_TYPE_IP)))
             {
                 //do operation
 
@@ -2910,6 +2987,11 @@ static void fpCreateServiceMapPortGroups(SnortConfig *sc)
     fpBuildServicePortGroups(sc->spgmmTable->udp_to_cli, sc->sopgTable->udp_to_cli,
                              sc->srmmTable->udp_to_cli, fp);
 
+    fpBuildServicePortGroups(sc->spgmmTable->sctp_to_srv, sc->sopgTable->sctp_to_srv,
+                             sc->srmmTable->sctp_to_srv, fp);
+    fpBuildServicePortGroups(sc->spgmmTable->sctp_to_cli, sc->sopgTable->sctp_to_cli,
+                             sc->srmmTable->sctp_to_cli, fp);
+
     fpBuildServicePortGroups(sc->spgmmTable->icmp_to_srv, sc->sopgTable->icmp_to_srv,
                              sc->srmmTable->icmp_to_srv, fp);
     fpBuildServicePortGroups(sc->spgmmTable->icmp_to_cli, sc->sopgTable->icmp_to_cli,
@@ -2950,6 +3032,14 @@ PORT_GROUP * fpGetServicePortGroupByOrdinal(sopg_table_t *sopg, int proto, int d
 
            break;
 
+       case IPPROTO_SCTP:
+           if (dir == TO_SERVER)
+               pg = sopg->sctp_to_srv[proto_ordinal];
+           else
+               pg = sopg->sctp_to_cli[proto_ordinal];
+
+           break;
+
        case IPPROTO_ICMP:
            if (dir == TO_SERVER)
                pg = sopg->icmp_to_srv[proto_ordinal];
@@ -3029,6 +3119,9 @@ static void fpPrintServiceRuleMaps(srmm_table_t *service_map)
     fpPrintServiceRuleMapTable( service_map->udp_to_srv,  "udp to server" );
     fpPrintServiceRuleMapTable( service_map->udp_to_cli,  "udp to client" );
 
+    fpPrintServiceRuleMapTable( service_map->sctp_to_srv,  "sctp to server" );
+    fpPrintServiceRuleMapTable( service_map->sctp_to_cli,  "sctp to client" );
+
     fpPrintServiceRuleMapTable( service_map->icmp_to_srv, "icmp to server" );
     fpPrintServiceRuleMapTable( service_map->icmp_to_cli, "icmp to client" );
 
@@ -3056,6 +3149,11 @@ void fpPrintServicePortGroupSummary(srmm_table_t *srvc_pg_map)
     if(srvc_pg_map->udp_to_cli->count)
     LogMessage("| udp to cient   : %d services\n",srvc_pg_map->udp_to_cli->count);
 
+    if(srvc_pg_map->sctp_to_srv->count)
+    LogMessage("| sctp to server  : %d services\n",srvc_pg_map->sctp_to_srv->count);
+    if(srvc_pg_map->sctp_to_cli->count)
+    LogMessage("| sctp to cient   : %d services\n",srvc_pg_map->sctp_to_cli->count);
+
     if(srvc_pg_map->icmp_to_srv->count)
     LogMessage("| icmp to server : %d services\n",srvc_pg_map->icmp_to_srv->count);
     if(srvc_pg_map->icmp_to_cli->count)
diff --git a/src/fpcreate.h b/src/fpcreate.h
index 00817b9..cd7dbb9 100644
--- a/src/fpcreate.h
+++ b/src/fpcreate.h
@@ -45,7 +45,7 @@ struct _SnortConfig;
 
 /*
  *  Max Number of Protocols Supported by Rules in fpcreate.c
- *  for tcp,udp,icmp,ip ... this is an array dimesnion used to
+ *  for tcp,udp,sctp,icmp,ip ... this is an array dimesnion used to
  *  map protocol-ordinals to port_groups ...
  */
 /* This is now defined in sftarget_protocol_refererence.h"
@@ -116,6 +116,9 @@ typedef struct
   SFGHASH * udp_to_srv;
   SFGHASH * udp_to_cli;
 
+  SFGHASH * sctp_to_srv;
+  SFGHASH * sctp_to_cli;
+
   SFGHASH * icmp_to_srv;
   SFGHASH * icmp_to_cli;
 
@@ -135,6 +138,9 @@ typedef struct
   PORT_GROUP *udp_to_srv[MAX_PROTOCOL_ORDINAL];
   PORT_GROUP *udp_to_cli[MAX_PROTOCOL_ORDINAL];
 
+  PORT_GROUP *sctp_to_srv[MAX_PROTOCOL_ORDINAL];
+  PORT_GROUP *sctp_to_cli[MAX_PROTOCOL_ORDINAL];
+
   PORT_GROUP *icmp_to_srv[MAX_PROTOCOL_ORDINAL];
   PORT_GROUP *icmp_to_cli[MAX_PROTOCOL_ORDINAL];
 
@@ -167,6 +173,7 @@ void FastPatternConfigFree(FastPatternConfig *);
 */
 int prmFindRuleGroupTcp(PORT_RULE_MAP *, int, int, PORT_GROUP **, PORT_GROUP **, PORT_GROUP **);
 int prmFindRuleGroupUdp(PORT_RULE_MAP *, int, int, PORT_GROUP **, PORT_GROUP **, PORT_GROUP **);
+int prmFindRuleGroupSctp(PORT_RULE_MAP *, int, int, PORT_GROUP **, PORT_GROUP **, PORT_GROUP **);
 int prmFindRuleGroupIp(PORT_RULE_MAP *, int, PORT_GROUP **, PORT_GROUP **);
 int prmFindRuleGroupIcmp(PORT_RULE_MAP *, int, PORT_GROUP **, PORT_GROUP **);
 
diff --git a/src/fpdetect.c b/src/fpdetect.c
index 72616ff..89f95aa 100644
--- a/src/fpdetect.c
+++ b/src/fpdetect.c
@@ -103,6 +103,7 @@ static inline int fpEvalHeaderIp(Packet *p, int ip_proto, OTNX_MATCH_DATA *);
 static inline int fpEvalHeaderIcmp(Packet *p, OTNX_MATCH_DATA *);
 static inline int fpEvalHeaderTcp(Packet *p, OTNX_MATCH_DATA *);
 static inline int fpEvalHeaderUdp(Packet *p, OTNX_MATCH_DATA *);
+static inline int fpEvalHeaderSctp(Packet *p, OTNX_MATCH_DATA *);
 static inline int fpEvalHeaderSW(PORT_GROUP *port_group, Packet *p,
                                  int check_ports, char ip_rule, OTNX_MATCH_DATA *);
 static int rule_tree_match (void* id, void * tree, int index, void * data, void *neg_list );
@@ -1032,6 +1033,7 @@ void printRuleFmt1( OptTreeNode * otn )
 
     if(      rtn->proto== IPPROTO_TCP     )LogMessage("tcp  ");
     else if( rtn->proto== IPPROTO_UDP     )LogMessage("udp  ");
+    else if( rtn->proto== IPPROTO_SCTP    )LogMessage("sctp ");
     else if( rtn->proto== IPPROTO_ICMP    )LogMessage("icmp ");
     else if( rtn->proto== ETHERNET_TYPE_IP)LogMessage("ip   ");
 
@@ -1064,7 +1066,7 @@ void printRuleFmt1( OptTreeNode * otn )
 **  FORMAL INPUTS
 **    PORT_GROUP * - the port group to inspect
 **    Packet *     - the packet to inspect
-**    int          - whether src/dst ports should be checked (udp/tcp or icmp)
+**    int          - whether src/dst ports should be checked (udp/tcp/sctp or icmp)
 **    char         - whether the rule is an IP rule (change the packet payload pointer)
 **
 **  FORMAL OUTPUTS
@@ -1533,6 +1535,90 @@ static inline int fpEvalHeaderTcp(Packet *p, OTNX_MATCH_DATA *omd)
 }
 
 /*
+**  fpEvalHeaderSctp::
+*/
+static inline int fpEvalHeaderSctp(Packet *p, OTNX_MATCH_DATA *omd)
+{
+    PORT_GROUP *src = NULL, *dst = NULL, *gen = NULL;
+
+#ifdef TARGET_BASED
+    if (IsAdaptiveConfigured(getRuntimePolicy(), 0))
+    {
+        int16_t proto_ordinal = GetProtocolReference(p);
+
+        DEBUG_WRAP(DebugMessage(DEBUG_ATTRIBUTE, "proto_ordinal=%d\n", proto_ordinal););
+
+        if (proto_ordinal > 0)
+        {
+            if (p->packet_flags & PKT_FROM_SERVER) /* to cli */
+            {
+                DEBUG_WRAP(DebugMessage(DEBUG_ATTRIBUTE, "pkt_from_server\n"););
+
+                src = fpGetServicePortGroupByOrdinal(snort_conf->sopgTable, IPPROTO_SCTP,
+                                                     0 /*to_cli */,  proto_ordinal);
+            }
+
+            if (p->packet_flags & PKT_FROM_CLIENT) /* to srv */
+            {
+                DEBUG_WRAP(DebugMessage(DEBUG_ATTRIBUTE, "pkt_from_client\n"););
+
+                dst = fpGetServicePortGroupByOrdinal(snort_conf->sopgTable, IPPROTO_SCTP,
+                                                     1 /*to_srv */,  proto_ordinal);
+            }
+
+            DEBUG_WRAP(DebugMessage(DEBUG_ATTRIBUTE,
+                        "fpEvalHeaderSctp:targetbased-ordinal-lookup: "
+                        "sport=%d, dport=%d, proto_ordinal=%d, src:%x, "
+                        "dst:%x, gen:%x\n",p->sp,p->dp,proto_ordinal,src,dst,gen););
+        }
+    }
+
+    if ((src == NULL) && (dst == NULL))
+    {
+        /* we did not have a target based group, use ports */
+        if (!prmFindRuleGroupSctp(snort_conf->prmSctpRTNX, p->dp, p->sp, &src, &dst, &gen))
+            return 0;
+
+        DEBUG_WRAP(DebugMessage(DEBUG_ATTRIBUTE,
+                    "fpEvalHeaderSctp: sport=%d, "
+                    "dport=%d, src:%x, dst:%x, gen:%x\n",p->sp,p->dp,src,dst,gen););
+    }
+#else
+    if (!prmFindRuleGroupSctp(snort_conf->prmSctpRTNX, p->dp, p->sp, &src, &dst, &gen))
+        return 0;
+#endif
+
+    if (fpDetectGetDebugPrintNcRules(snort_conf->fast_pattern_config))
+    {
+        LogMessage(
+            "fpEvalHeaderSctp: sport=%d, dport=%d, src:%p, dst:%p, gen:%p\n",
+             p->sp, p->dp, (void*)src, (void*)dst, (void*)gen);
+    }
+
+    InitMatchInfo(omd);
+
+    if (dst != NULL)
+    {
+        if (fpEvalHeaderSW(dst, p, 1, 0, omd))
+            return 1;
+    }
+
+    if (src != NULL)
+    {
+        if (fpEvalHeaderSW(src, p, 1, 0, omd))
+            return 1;
+    }
+
+    if (gen != NULL)
+    {
+        if(fpEvalHeaderSW(gen, p, 1, 0, omd))
+            return 1;
+    }
+
+    return fpFinalSelectEvent(omd, p);
+}
+
+/*
 **  fpEvalHeaderICMP::
 */
 static inline int fpEvalHeaderIcmp(Packet *p, OTNX_MATCH_DATA *omd)
@@ -1603,10 +1689,10 @@ static inline int fpEvalHeaderIp(Packet *p, int ip_proto, OTNX_MATCH_DATA *omd)
 **
 **  DESCRIPTION
 **    This function is the interface to the Detect() routine.  Here
-**    the IP protocol is processed.  If it is TCP, UDP, or ICMP, we
-**    process the both that particular ruleset and the IP ruleset
+**    the IP protocol is processed.  If it is TCP, UDP, SCTP, or ICMP,
+**    we process the both that particular ruleset and the IP ruleset
 **    with in the fpEvalHeader for that protocol.  If the protocol
-**    is not TCP, UDP, or ICMP, we just process the packet against
+**    is not TCP, UDP, SCTP, or ICMP, we just process the packet against
 **    the IP rules at the end of the fpEvalPacket routine.  Since
 **    we are using a setwise methodology for snort rules, both the
 **    network layer rules and the transport layer rules are done
@@ -1680,6 +1766,18 @@ int fpEvalPacket(Packet *p)
 
             return fpEvalHeaderUdp(p, omd);
 
+        case IPPROTO_SCTP:
+            DEBUG_WRAP(DebugMessage(DEBUG_DETECT,
+                        "Detecting on SctpList\n"););
+
+            if(p->sctph == NULL)
+            {
+                ip_proto = -1;
+                break;
+            }
+
+            return fpEvalHeaderSctp(p, omd);
+
         case IPPROTO_ICMPV6:
         case IPPROTO_ICMP:
             DEBUG_WRAP(DebugMessage(DEBUG_DETECT,
@@ -1698,7 +1796,7 @@ int fpEvalPacket(Packet *p)
     }
 
     /*
-    **  No Match on TCP/UDP, Do IP
+    **  No Match on TCP/UDP/SCTP, Do IP
     */
     return fpEvalHeaderIp(p, ip_proto, omd);
 }
